//T24_EEP02.c
#include <avr/io.h> 
#include <util/delay.h> 

#define setbit(P,BIT)  ((P) |= (1<<(BIT)))  //Portbit setzen
#define clearbit(P,BIT) ((P) &=~(1<<(BIT))) //Portbit loeschen 
#define togglebit(P,BIT) ((P) ^=(1<<(BIT))) //Zustand des Port- 
                                            //bits umschalten                         
int i;
unsigned char j,k,w;
unsigned char anz_werte[17];

//vgl. Datenblaetter ATtiny24/44/84, S. 18, C Code Example 
void EEPROM_write(unsigned int ucAddress,unsigned char ucData)
{
	while(EECR & (1<<EEPE));
	EECR=(0<<EEPM1)|(0<<EEPM0);
	EEAR=ucAddress;
	EEDR=ucData;
	EECR |= (1<<EEMPE);
	EECR |= (1<<EEPE);
}
//vgl. Datenblaetter ATtiny24/44/84, S. 18, C Code Example 
   
unsigned char EEPROM_read(unsigned int ucAddress)
{
while(EECR & (1<<EEPE));
EEAR=ucAddress;
EECR |=(1<<EERE);
return EEDR;
}
void seg_anz()
{
anz_werte[0]=63;  //0
anz_werte[1]=6;   //1
anz_werte[2]=91;  //2
anz_werte[3]=79;  //3
anz_werte[4]=102; //4
anz_werte[5]=109; //5
anz_werte[6]=125; //6
anz_werte[7]=7;   //7
anz_werte[8]=127; //8
anz_werte[9]=111; //9
anz_werte[10]=119;//A
anz_werte[11]=124;//b
anz_werte[12]=57; //C
anz_werte[13]=94; //d
anz_werte[14]=121;//E
anz_werte[15]=113;//F
}	
	
	

int main(void)
 {
DDRA=0xFF;
DDRB=0b00000111;
clearbit(PORTB,PB1);//Portbit 1 geloescht
seg_anz();//dem Array anz_werte[x] Werte zuweisen lassen  

//An die Adressen 0 .. 0x0F im EEPROM Werte zur
//Darstellung der Zeichen 0..9 sowie A..F auf einer
//Siebensegmentanzeige mit gemeinsamer Katode uebertragen

 EEPROM_write(0x00,0x3F);//0
 _delay_ms(10);
 EEPROM_write(0x01,0x06);//1
 _delay_ms(10);
 EEPROM_write(0x02,0x56);//2
 _delay_ms(10);
 EEPROM_write(0x03,0x4F);//3
 _delay_ms(10);
 EEPROM_write(0x04,0x66);//4
 _delay_ms(10);
 EEPROM_write(0x05,0x6D);//5
 _delay_ms(10);
 EEPROM_write(0x06,0x7D);//6
 _delay_ms(10);
 EEPROM_write(0x07,0x07);//7
 _delay_ms(10);
 EEPROM_write(0x08,0x7F);//8
 _delay_ms(10);
 EEPROM_write(0x09,0x6F);//9
 _delay_ms(10);
 EEPROM_write(0x0A,0x77);//A
 _delay_ms(10);
 EEPROM_write(0x0B,0x7C);//b
 _delay_ms(10);
 EEPROM_write(0x0C,0x39);//C
 _delay_ms(10);
 EEPROM_write(0x0D,0x39);//d
 _delay_ms(10);
 EEPROM_write(0x0E,0x79);//E
 _delay_ms(10);
 EEPROM_write(0x0F,0x71);//F
 _delay_ms(10);   
 
unsigned char EE_byte,H_nib,L_nib;
while(1)
{
for (i=0; i<16; i++)// for 1, 16 in das EEPROM zuvor 
                    // uebertragene Bytes als zwei 
                    // HEX-Zeichen anzeigen                      
{
	EE_byte=EEPROM_read(i);
	L_nib=(EE_byte & 0x0F);
	H_nib=((EE_byte & 0xF0)>>4);	
	for (j=0;j<100;j++)// for 2, 100 mal beide  Anzeigen 
{                      // abwechselnd einschalten   
	clearbit(PORTB,PB1);//Anzeige rechts ein	
	w=L_nib;
	PORTA=anz_werte[w];         
	_delay_ms(10);     
	setbit(PORTB,PB1);  //Anzeige links ein	
	w=H_nib;
	PORTA=anz_werte[w];
	_delay_ms(10);     
}//Ende for 1	
}//Ende for 2
}//Ende while(1)
}//Ende main
