#!/usr/bin/python
#AVR_ISP_contr.py


#H. Nieder, Sommer 2016 und Mai 2020

import sys
import time
import RPi.GPIO as GPIO
import Tkinter as Tk
from tkFileDialog import *
import ScrolledText as Tkst

#GPIO-Pins
MOSI=8
SCK =7
MISO=25
RES=23

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#Anfangszustand
out(RES,low)

Byte=0
z=0

#Dez-->Hex
HEX_dt=("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F")
def ByteToHex(Byte):
    Lo_nib=0
    Hi_nib=0     
    Hi_nib=Byte/16
    Lo_nib=Byte%16      
    ByteHex=HEX_dt[Hi_nib]+HEX_dt[Lo_nib]      
    return ByteHex


#Byte_in=0

def SPI_in():
    global Byte_in
    out(SCK,hi)
    Byte_in=0
    Bit7=128
    n=0
    for n in range(0,8):             
        out(SCK,low)
        time.sleep(0.0001)
        if (GPIO.input(MISO)):
            Byte_in=Byte_in+Bit7               
        time.sleep(0.0001)
        out(SCK,hi)
        time.sleep(0.0001)                
        Bit7=Bit7>>1       
    time.sleep(0.0001)
    Ergebnis=Byte_in
    Zahl=ByteToHex(Byte_in)
    #print Zahl,
   

def SPI_out(Byte):
    Bit7_wt=128
    n=0
    for n in range(0,8):
        if (Byte & Bit7_wt)>0:
            out(MOSI,low)      
        else:
            out(MOSI,hi)
        time.sleep(0.00002)#2
        out(SCK,low)
        Bit7_wt=Bit7_wt>>1        
        time.sleep(0.00002)
        out(SCK,hi)
        time.sleep(0.00002)    
    out(MOSI,hi)
    

def prog_en():
    SPI_out(0xAC)
    SPI_out(0x53)
    SPI_out(0)
    SPI_out(0)    

def prog_start():
    out(RES,hi)
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en() 

def prog_end():
    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low)  


def read_EEP():
    m=0
    k_e=0
    p=0
    summe_e=0
    line_e=""
    line_re=""
    adr_tmp=0
    prog_start()
    #print
    inpt=entr.get()
    m=int(inpt)

    if m<4096:
        m_16=m/8
        m_16r=m%8;
        adr_hi=adr_tmp/256
        adr_lo=adr_tmp%256   
        if m_16>0:
            for je in range(0,m_16):
                line_e= ":"+"10"+ByteToHex(adr_hi)+ByteToHex(adr_lo)+"00"    
            
                summe_e=16+adr_hi+adr_lo
                for adr in range(p,p+16):
        
                    SPI_out(0xA0)        
                    adr_hi=adr/256
                    #print"adr_hi: ",adr_hi
                    adr_lo=adr%256
                    #print" adr_lo: ",adr_lo
                    #print
                    SPI_out(adr_hi)
                    SPI_out(adr_lo)
                    SPI_in()
                    line_e=line_e+ByteToHex(Byte_in)
                    summe_e=summe_e+Byte_in
                                               
                    k_e=k_e+1
                    if k_e==16:
                        #print"Summe_e: ",summe_e
                        #print  
                        mod_wt=summe_e%256
                        if mod_wt==0:    # 
                            mod_wt=256   #
                        p_summe=256-mod_wt
                        line_e=line_e+ByteToHex(p_summe)
                        txt.insert("end",line_e+"\r\n")
                        #print
                        k_e=0
                        p=p+16
                        summe_e=0
                adr_tmp=adr_tmp+16
                adr_hi=adr_tmp/256
                adr_lo=adr_tmp%256
                    
        if m_16r==0:
               
            txt.insert("end",":00000001FF"+"\r\n")
            txt.insert("end","\n") 
           
        if m_16r>0:
            adr_hi=adr_tmp/256
            adr_lo=adr_tmp%256  
            line_re =":"+ByteToHex(m_16r*2)+ByteToHex(adr_hi)+ByteToHex( adr_lo)+"00"
            summe=(m_16r*2)+adr_hi+adr_lo
            for ad in range(p,p+m_16r*2):
                SPI_out(0xA0)        
                adr_hi=adr/256
                adr_lo=adr%256
                SPI_out(adr_hi)
                SPI_out(adr_lo)
                SPI_in()
                line_re=line_re+ByteToHex(Byte_in)
                summe=summe+Byte_in
                k_e=k_e+1
                if k_e==m_16r*2:
                    mod_wt=summe%256
                    if mod_wt==0:
                        mod_wt=256 
                    #print"summe: ",summe
                    #print
                    #print"mod_wt: ",mod_wt
                    #print  
                    p_summe=256-mod_wt
                    #print"p_summe: ",p_summe
                    #print
                    line_re=line_re+ByteToHex(p_summe)
                    #print line_re 
                    txt.insert("end",line_re+"\r\n")
            
            txt.insert("end",":00000001FF"+"\r\n")
            txt.insert("end","\n")  
   
    n=0
    ad_tmp=0
    time.sleep(1)
    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low)

def read_mem():
    n=0    
    k=0
    q=0
    summe=0
    line=""
    ad_tmp=0
    out(RES,hi)#Reset on 
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en()    
    inpt=entr.get()
    n=int(inpt)
    if n<65536:
        n_16=n/8
        n_16r=n%8;
        ad_hi=ad_tmp/256
        ad_lo=ad_tmp%256   
        if n_16>0:
            for j in range(0,n_16):
                line= ":"+"10"+ByteToHex(ad_hi)+ByteToHex(ad_lo)+"00"  
                summe=16+ad_hi+ad_lo
                for ad in range(q,q+8):
                    SPI_out(0x20)        
                    ad_hi=ad/256
                    ad_lo=ad%256
                   
                    SPI_out(ad_hi)
                    SPI_out(ad_lo)
                    SPI_in()
                    line=line+ByteToHex(Byte_in)
                    summe=summe+Byte_in
                    SPI_out(0x28)
                    SPI_out(ad_hi)
                    SPI_out(ad_lo)
                    SPI_in()
                    line=line+ ByteToHex(Byte_in)
                    summe=summe+Byte_in
                    k=k+2
                    if k==16:
                         
                        mod_wt=summe%256
                        if mod_wt==0:    # 
                            mod_wt=256   # 
                        p_summe=256-mod_wt
                        line=line+ByteToHex(p_summe)
                        txt.insert("end",line+"\r\n")#
                        k=0
                        q=q+8
                        summe=0
                ad_tmp=ad_tmp+16
                ad_hi=ad_tmp/256
                ad_lo=ad_tmp%256
        if n_16r==0:
            txt.insert("end",":00000001FF"+"\r\n")
            txt.insert("end","\n") 
        if n_16r>0:
            ad_hi=ad_tmp/256
            ad_lo=ad_tmp%256  
            line_r =":"+ByteToHex(n_16r*2)+ByteToHex(ad_hi)+ByteToHex( ad_lo)+"00"
            summe=(n_16r*2)+ad_hi+ad_lo
            for ad in range(q,q+n_16r):
                SPI_out(0x20)        
                ad_hi=ad/256
                ad_lo=ad%256
                SPI_out(ad_hi)
                SPI_out(ad_lo)
                SPI_in()
                line_r=line_r+ByteToHex(Byte_in)
                summe=summe+Byte_in
                SPI_out(0x28)
                SPI_out(ad_hi)
                SPI_out(ad_lo)
                SPI_in()
                line_r=line_r+ ByteToHex(Byte_in)
                summe=summe+Byte_in                       
                k=k+1
                if k==n_16r:
                    mod_wt=summe%256
                    if mod_wt==0:    # 
                        mod_wt=256   #                    
                    p_summe=256-mod_wt                    
                    line_r=line_r+ByteToHex(p_summe)
                    txt.insert("end",line_r+"\r\n")          
            txt.insert("end",":00000001FF"+"\r\n")
            txt.insert("end","\n") 
    n=0
    ad_tmp=0
    time.sleep(1)
    prog_end()

def read_signature():
    global line#
    line=""
    prog_start()
    
    SPI_out(0x30)
    SPI_out(0x00)
    SPI_out(0x00)
    SPI_in()
    line=ByteToHex(Byte_in)+" "
    
    SPI_out(0x30)
    SPI_out(0x00)
    SPI_out(0x01)
    SPI_in()
    line=line+ByteToHex(Byte_in)+" "

    SPI_out(0x30)
    SPI_out(0x00)
    SPI_out(0x02)
    SPI_in()
    line=line+ByteToHex(Byte_in)+" *"
    txt.insert("end",line+"\n")
    txt.insert("end","\n")         
    time.sleep(1)
    prog_end()

def end():
    main.destroy()

#Show text
def EEPROM_show():
    #txt.insert("end","EEPROM:")  
    #txt.insert("end","\n")
    #txt.insert("end","\n")    
    read_EEP()

def progmem_show():
    #txt.insert("end","Program Memory:")  
    #txt.insert("end","\n") 
    #txt.insert("end","\n")    
    read_mem()



def signature_show():
    txt.insert("end","       Signature  Bytes:    * ")
    read_signature()

def fuse_ext_show():    
    
    txt.insert("end","       Fuse Ext. Byte: ")
    
    line_e=""
    #Fuse High Byte():
    SPI_out(0x50)
    SPI_out(0x08)
    SPI_out(0x00)
    SPI_in()
    
    if Byte_in>=128:
        line_e=line_e+"{0:4d}{0:4X}{0:9b}".format(Byte_in)
    if Byte_in<128:
        line_e=line_e+"{0:4d}{0:4X}".format(Byte_in)+" 0"+"{0:7b}".format(Byte_in)
    txt.insert("end",line_e+"\n")
    txt.insert("end","\n")
        

def fuse_hi_show():
    txt.insert("end","       Fuse High Byte: ")
    
    line_h=""
    #fuse_hi_byte():
    SPI_out(0x58)
    SPI_out(0x08)
    SPI_out(0x00)
    SPI_in()
    
    if Byte_in>=128:
        line_h=line_h+"{0:4d}{0:4X}{0:9b}".format(Byte_in)
    if Byte_in<128:
        line_h=line_h+"{0:4d}{0:4X}".format(Byte_in)+" 0"+"{0:7b}".format(Byte_in) 
    txt.insert("end",line_h+"\n")
    txt.insert("end","\n")
      


def fuse_low_show():
    txt.insert("end","       Fuse Low  Byte: ")
    
    line_l=""
    #Fuse Low Byte():
    SPI_out(0x50)
    SPI_out(0x00)
    SPI_out(0x00)
    SPI_in()
    
    if Byte_in>=128:
        line_l=line_l+"{0:4d}{0:4X}{0:9b}".format(Byte_in)
    if Byte_in<128:
        line_l=line_l+"{0:4d}{0:4X}".format(Byte_in)+" 0"+"{0:7b}".format(Byte_in)
    txt.insert("end",line_l+"\n")
    txt.insert("end","\n")  
    

def fusebytes_show():
    prog_start()
    fuse_ext_show()
    fuse_hi_show()
    fuse_low_show() 
    prog_end()

def fbL_Rd():
    prog_start()
    fuse_low_show()
    prog_end()

def fbH_Rd():
    prog_start()
    fuse_hi_show()
    prog_end()

def fbE_Rd():
    prog_start()
    fuse_ext_show()
    prog_end()

def lock_bt_show():
    line_lo=""
    prog_start()

    txt.insert("end","       Lock Bit  Byte:")

    #Lock Byte():
    SPI_out(0x58)
    SPI_out(0x00)
    SPI_out(0x00)
    SPI_in()
   
    line_lo=line_lo+"{0:5d}{0:4X}{0:9b}".format(Byte_in)
    txt.insert("end",line_lo+"\n")
    txt.insert("end","\n")  
    
    prog_end()

def cal_bt_show():
    line_ca=""
    prog_start()

    txt.insert("end","       Calibrat. Byte:  ")
   
    #Calibration Byte():
    SPI_out(0x38)
    SPI_out(0x00)
    SPI_out(0x00)
    SPI_in()
    
    line_ca=line_ca+"{0:2d}{0:4X}{0:9b}".format(Byte_in)
    txt.insert("end",line_ca+"\n")
    txt.insert("end","\n")  
    
    prog_end()

def Delete_show():
    txt.delete(1.0,"end")# 
    



main=Tk.Tk()
main.title("AVR ISP Control Panel")
frame=Tk.Frame(main,bg="white")
frame.pack(fill="both",expand="yes")

fbt=0
fbt0=0
fbt1=0
fbt2=0
fbt3=0
fbt4=0
fbt5=0
fbt6=0
fbt7=0

def show_B7():
    line_fb=""
    global fbt7
    fb7=mb7.get()
    if fb7=="1":
        fbt7=0
        label7.config(text="0")
    if fb7=="0":
        fbt7=1
        label7.config(text="1")
  
def show_B6():
    line_fb=""
    global fbt6
    fb6=mb6.get()
    if fb6=="1":
        fbt6=0 
        label6.config(text="0")
    if fb6=="0":
        fbt6=1
        label6.config(text="1")
  
def show_B5():
    line_fb=""
    global fbt5
    fb5=mb5.get()
    if fb5=="1":
        fbt5=0
        label5.config(text="0")
    if fb5=="0":
        fbt5=1
        label5.config(text="1")

def show_B4():
    line_fb=""
    global fbt4
    fb4=mb4.get()
    if fb4=="1":
        fbt4=0
        label4.config(text="0")
    if fb4=="0":
        fbt4=1
        label4.config(text="1")
 
def show_B3():
    line_fb=""
    global fbt3
    fb3=mb3.get()
    if fb3=="1":
        fbt3=0 
        label3.config(text="0")
    if fb3=="0":
        fbt3=1
        label3.config(text="1")
 
def show_B2():
    line_fb=""
    global fbt2
    fb2=mb2.get()
    if fb2=="1":
        fbt2=0
        label2.config(text="0")
    if fb2=="0":
        fbt2=1
        label2.config(text="1")
    
def show_B1():
    line_fb=""
    global fbt1
    fb1=mb1.get()
    if fb1=="1":
        fbt1=0
        label1.config(text="0")
    if fb1=="0":
        fbt1=1
        label1.config(text="1")

def show_B0():
    line_fb="" 
    global fbt0
    fb0=mb0.get()
    if fb0=="1":
        fbt0=0 
        label0.config(text="0")
    if fb0=="0":
        fbt0=1  
        label0.config(text="1")
   
def Fb_enter():
    line_fb=""   
    global fbt,fbt7,fbt6,fbt5,fbt4,fbt3,fbt2,fbt1,fbt0    
    fbt=128*fbt7+64*fbt6+32*fbt5+16*fbt4+8*fbt3+4*fbt2+2*fbt1+fbt0 
    line_fb=line_fb+"{0:4d}".format(fbt)

def FbE_prog():
    out(RES,hi)
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en()
    ein_fb=entr_fbH.get()
    Byte=int(ein_fb)
    
    #Write Fuse High Byte
    SPI_out(0xAC)
    SPI_out(0xA4)
    SPI_out(0x00)
    SPI_out(Byte)  

    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low)  

def FbH_prog():
    out(RES,hi)
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en()

    ein_fb=entr_fbH.get()
    Byte=int(ein_fb)  

    #Write Fuse Ext. Byte
    SPI_out(0xAC)
    SPI_out(0xA8)
    SPI_out(0x00)
    SPI_out(Byte)

    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low) 

def FbL_prog():
    out(RES,hi)
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en()

    ein_fb=entr_fbH.get()
    Byte=int(ein_fb)  
    
    #write Fuse Low Byte
    SPI_out(0xAC)
    SPI_out(0xA0)
    SPI_out(0x00)
    SPI_out(Byte)
       
    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low)  

def Lock_bt_prog():
    out(RES,hi)
    time.sleep(0.5)
    prog_en()
    time.sleep(0.5)
    prog_en()

    ein_fb=entr_fbH.get()
    Byte=int(ein_fb)  
    
    #write Lock bits
    SPI_out(0xAC)
    SPI_out(0xE0)
    SPI_out(0x00)
    SPI_out(Byte)
       
    out(MOSI,low)
    out(SCK,low)
    time.sleep(1)
    out(RES,low)  



def Lbt_Rd():
     lock_bt_show()

counter1=0

def counter1_label(label_fLbyte):
    
    def count1():
        global counter1
        counter1 +=1
        fbt=128*fbt7+64*fbt6+32*fbt5+16*fbt4+8*fbt3+4*fbt2+2*fbt1+fbt0
        label_fLbyte.config(text=str(fbt))
        label_fLbyte.after(1000, count1)
    count1()

def SaveasFile():
    f=asksaveasfile(mode='w')
    t=txt.get(0.0,"end")
    try:
        f.write(t.rstrip())
    except:
        showerror(title='Error!',message='Error while saving file')

def OpenFile():
    
    f=askopenfile(mode='r')
    #txt.insert("end",f)
    t=f.read()
    #txt.delete(0.0,"end+""-1c")##
    #txt.insert("end",filename)
    txt.insert(0.0,t)

menu = Tk.Menu(main)
filemenu = Tk.Menu(menu)
filemenu.add_command(label="Open...", command=OpenFile)
filemenu.add_command(label='Save as',command=SaveasFile)

#Variables
mb7=Tk.StringVar()
mb7.set("1")
mb6=Tk.StringVar()
mb6.set("1")
mb5=Tk.StringVar()
mb5.set("1")
mb4=Tk.StringVar()
mb4.set("1")
mb3=Tk.StringVar()
mb3.set("1")
mb2=Tk.StringVar()
mb2.set("1")
mb1=Tk.StringVar()
mb1.set("1")
mb0=Tk.StringVar()
mb0.set("1")

frame1=Tk.Frame(main,width=200,height=80)
frame1.pack(side="top")

frameL=Tk.Frame(frame1,width=50,height=20)
frameL.pack(side="left")

#Scrolled Text
txt=Tkst.ScrolledText(master=frameL,wrap="word",width=45,height=20)#
txt.pack(side="top",padx=5)


memshow=Tk.Button(frameL,text="Read Program Memory",command=progmem_show,width=30)
memshow.pack(side="top",pady=6)

framea=Tk.Frame(frameL,width=30,height=20)
framea.pack(side="top",pady=3)

labl=Tk.Label(framea,text="Words to show :  ")
labl.pack(side="left")

entr=Tk.Entry(framea,text="16",width="7")
entr.insert("end","16")
entr.pack(side="left")

EEPshow=Tk.Button(frameL,text="Read EEPROM Data Memory",command=EEPROM_show,width=30)
EEPshow.pack(side="top",pady=6)

frameL1=Tk.Frame(frameL,width=50,height=20)
frameL1.pack(side="top")

frameR=Tk.Frame(frame1,width=50,height=20)

#********************************************************************
def frameR_show():
    frameR.pack(side="left")
    frameR_on.pack_forget()
    delete_txt_bt2.pack_forget()
    bend2.pack_forget()
    
def frameR_hide():
    frameR.pack_forget()    
    delete_txt_bt2.pack(side="left",padx=5)
    frameR_on.pack(side="left") 
    bend2.pack(side="left",padx=5)
    
delete_txt_bt2=Tk.Button(frameL1,text="New Text",command=Delete_show)
delete_txt_bt2.pack(side="left",padx=5,pady=5)

frameR_on=Tk.Button(frameL1,text="Expand Panel",command=frameR_show)
frameR_on.pack(side="left",padx=1,pady=5)


bend2=Tk.Button(frameL1,text="End",command=end) 
bend2.pack(side="left",padx=5,pady=5) 

#********************************************************************

Fuses_show=Tk.Button(frameR,text=" Read  Fuse  Bytes ",command=fusebytes_show,width=30)
Fuses_show.pack(side="top",pady=15)

label_Fuses=Tk.Label(frameR,text="( 0  =  programmed, 1  =  unprogrammed )")
label_Fuses.pack(side="top",pady=5)

frame1a=Tk.Frame(frameR,width=30,height=20)
frame1a.pack(side="top",pady=10)

frame1b7=Tk.Frame(frame1a,width=30,height=20)
frame1b7.pack(side="left")
chb7=Tk.Checkbutton(frame1b7,text="B7",var=mb7,command=show_B7)
chb7.pack(side="top")
label7=Tk.Label(frame1b7,text="1")
label7.pack(side="top")

frame1b6=Tk.Frame(frame1a,width=30,height=20)
frame1b6.pack(side="left")
chb6=Tk.Checkbutton(frame1b6,text="B6",var=mb6,command=show_B6)
chb6.pack(side="top")
label6=Tk.Label(frame1b6,text="1")
label6.pack(side="top")

frame1b5=Tk.Frame(frame1a,width=30,height=20)
frame1b5.pack(side="left")
chb5=Tk.Checkbutton(frame1b5,text="B5",var=mb5,command=show_B5)
chb5.pack(side="top")
label5=Tk.Label(frame1b5,text="1")
label5.pack(side="top")

frame1b4=Tk.Frame(frame1a,width=30,height=20)
frame1b4.pack(side="left")
chb4=Tk.Checkbutton(frame1b4,text="B4",var=mb4,command=show_B4)
chb4.pack(side="top")
label4=Tk.Label(frame1b4,text="1")
label4.pack(side="top")

frame1b3=Tk.Frame(frame1a,width=30,height=20)
frame1b3.pack(side="left")
chb3=Tk.Checkbutton(frame1b3,text="B3",var=mb3,command=show_B3)
chb3.pack(side="top")
label3=Tk.Label(frame1b3,text="1")
label3.pack(side="top")

frame1b2=Tk.Frame(frame1a,width=30,height=20)
frame1b2.pack(side="left")
chb2=Tk.Checkbutton(frame1b2,text="B2",var=mb2,command=show_B2)
chb2.pack(side="top")
label2=Tk.Label(frame1b2,text="1")
label2.pack(side="top")

frame1b1=Tk.Frame(frame1a,width=30,height=20)
frame1b1.pack(side="left")
chb1=Tk.Checkbutton(frame1b1,text="B1",var=mb1,command=show_B1)
chb1.pack(side="top")
label1=Tk.Label(frame1b1,text="1")
label1.pack(side="top")

frame1b0=Tk.Frame(frame1a,width=30,height=20)
frame1b0.pack(side="left")
chb0=Tk.Checkbutton(frame1b0,text="B0",var=mb0,command=show_B0)
chb0.pack(side="top")
label0=Tk.Label(frame1b0,text="1")
label0.pack(side="top")

#************************************************

frame1b=Tk.Frame(frameR,width=30,height=20)
frame1b.pack(side="top",pady=5)

label_fb=Tk.Label(frame1b,text="Calculated Byte:  ")
label_fb.pack(side="left")

label_fLbyte=Tk.Label(frame1b,text="000")
label_fLbyte.pack(side="left")
counter1_label(label_fLbyte)

#************************************************

frame1Prg=Tk.Frame(frameR,width=30,height=20)
frame1Prg.pack(side="top")

frame1c1=Tk.Frame(frame1Prg,width=30,height=20)
frame1c1.pack(side="left")

fbL_R=Tk.Button(frame1c1,text="Read",command=fbL_Rd)
fbL_R.pack(side="top",pady=2)

fbH_R=Tk.Button(frame1c1,text="Read",command=fbH_Rd)
fbH_R.pack(side="top",pady=2)

fbE_R=Tk.Button(frame1c1,text="Read",command=fbE_Rd)
fbE_R.pack(side="top",pady=2)

Lbt_R=Tk.Button(frame1c1,text="Read",command=Lbt_Rd)
Lbt_R.pack(side="top",pady=2)

frame1c2=Tk.Frame(frame1Prg,width=30,height=20)
frame1c2.pack(side="left")

label_fbL=Tk.Label(frame1c2,text="Fuse Low Byte: ",width=12)
label_fbL.pack(side="top",padx=3,pady=8)

label_fbH=Tk.Label(frame1c2,text="Fuse High Byte:",width=12)
label_fbH.pack(side="top",padx=3,pady=8)

label_fbE=Tk.Label(frame1c2,text="Fuse Ext. Byte: ",width=12)
label_fbE.pack(side="top",padx=3,pady=8)

label_lockb=Tk.Label(frame1c2,text="Lock        bits : ",width=12)
label_lockb.pack(side="top",padx=3,pady=8)

#************************************************

frame1d=Tk.Frame(frame1Prg,width=30,height=20)
frame1d.pack(side="left")

entr_fbH=Tk.Entry(frame1d,text="   ",width="3")
entr_fbH.pack(side="top",padx=5,pady=20)

#************************************************

frame1e=Tk.Frame(frame1Prg,width=30,height=20)
frame1e.pack(side="left")

fb_btnL=Tk.Button(frame1e,text="Prog.",command=FbL_prog)
fb_btnL.pack(side="top",pady=2)

fb_btnH=Tk.Button(frame1e,text="Prog.",command=FbH_prog)
fb_btnH.pack(side="top",pady=2)

fb_btnE=Tk.Button(frame1e,text="Prog.",command=FbE_prog)
fb_btnE.pack(side="top",pady=2)

lockbt_pr=Tk.Button(frame1e,text="Prog.",command=Lock_bt_prog)
lockbt_pr.pack(side="top",pady=2)

#************************************************

#Lock_show=Tk.Button(frameR,text="Read   Lock   Bit   Byte",command=lock_bt_show,width=30)
#Lock_show.pack(side="top",pady=5)

frame1f=Tk.Frame(frameR,width=30,height=20)
frame1f.pack(side="top")

signatureshow=Tk.Button(frame1f,text="Read Sig. Bytes",command=signature_show)
signatureshow.pack(side="left",pady=3,padx=12)

Cal_show=Tk.Button(frame1f,text="Read Cal. Byte",command=cal_bt_show)
Cal_show.pack(side="left",pady=2,padx=12)

frameR1=Tk.Frame(frameR,width=30, height=20)
frameR1.pack(side="top",pady=6)

delete_txt_bt=Tk.Button(frameR1,text="New Text",command=Delete_show)
delete_txt_bt.pack(side="left") 

frameR_off=Tk.Button(frameR1,text="Reduce Panel",command=frameR_hide)
frameR_off.pack(side="left",padx=2)

bend=Tk.Button(frameR1,text="  End  ",command=end)
bend.pack(side="left")

main["menu"]= filemenu

main.mainloop()



